# Surgeweb plain HTML interface
# This file handles ui actions either as whole page requests/updates (or in the case of ajax to page updates)

function swcmd_s(input,e)
{
	swcmd(input.value,e,input);
	if(input.value=='sw_copy' || input.value=='sw_move'){
#		do nothing
	}else{
		input.options[0].selected = true;
	}
}
function swcmd(action,e,input)
{
#	alert("requested to:"+action+" the messages="+sel.join(','));
	if (action=='sw_delete') 	do_delete();
	else if (action=='sw_read')		do_mark_read();
	else if (action=='sw_unread')	do_mark_unread();
	else if (action=='sw_reply_all')	do_reply_all();
	else if (action=='sw_forward') 	do_forward();
	else if (action=='sw_forward_attach') 	do_forward_attach();
	else if (action=='sw_redirect') 	do_redirect();
	else if (action=='sw_reply') 	do_reply();
	else if (action=='sw_copy') 	do_copy_show(e,input);
	else if (action=='sw_move') 	do_move_show(e,input);
	else alert('Sorry  don\'t know how to '+action+' yet');
}

function S(cmd,page)
{
	simple_submit(cmd,page);
}
function M(item)
{
	document.main.msg_id.value=item
	simple_submit('show','msg.htm');
}
function F(item, start, refresh)
{
	document.main.refresh.value="true";
	document.main.fld_id.value=item
	simple_submit('show','sw.htm');
}

function del(item)
{
	var f=document.main;
	f.cmd.value='delete';
	f.msg_id.value="";
	f.sel.value=item;
#	f.ui.value='raw';
	f.submit();
}


function show_raw(mid)
{
	open_popup('cmd=msgpart&sid='+sid+'&fld_id='+sw.fid+'&msg_id='+mid+'&part_id=0');
}
function show_text(mid,pid)
{
#	headers now say text/plain instead of text/html so no web encoding should be required
	open_popup('cmd=msgpart&sid='+sid+'&fld_id='+sw.fid+'&msg_id='+mid+'&part_id='+pid);
}
function show_html(mid,pid)
{
	open_popup('cmd=msgpart&sid='+sid+'&fld_id='+sw.fid+'&msg_id='+mid+'&part_id='+pid+'&process=simple_wash');
}


#||send_type|| [compose / reply / reply_all / forward / forward_attach / redirect]

function do_compose(){
	document.main.send_type.value='compose';
	document.main.msg_id.value='';	
	simple_submit('show','edit.htm');
}
function do_reply(){
	document.main.send_type.value='reply';
	simple_submit('show','edit.htm');
}
function do_forward(){
	document.main.send_type.value='forward';
	simple_submit('show','edit.htm');
}
function do_forward_attach(){
	document.main.send_type.value='forward_attach';
	simple_submit('show','edit.htm');
}
function do_redirect(){
	document.main.send_type.value='redirect';
	simple_submit('show','edit.htm');
}

function simple_submit(cmd,page,epage)
{
	var f=document.main;
	f.cmd.value=cmd;
	f.page.value=page;
	if (epage)
		f.epage.value=epage;
	f.submit();
}
function edit_discard(){
	if (!confirm("Discard message?")) return;
	simple_submit('show','sw.htm');
}
function do_save_draft(){
	msg_from_editor();
	set_compose_refresh();
	simple_submit('save_draft,show','edit.htm');
}
function do_send_move(){
	alert("Not implemented");
}
function do_send(){
	msg_from_editor();	
	set_compose_refresh(); // only used if send error
	simple_submit('send','sw.htm','edit.htm');
}
function do_delete(){
	simple_submit('delete,show','sw.htm');
}
function do_spam(){
	if (!confirm("Don't know how to report spam, delete instead?"))
		return;		
	do_delete();
}
function do_mark_read(){
	document.main.flags_action.value='set';
	document.main.flags.value='seen';
	simple_submit('set_flags,show','sw.htm');
}
function do_mark_unread(){
	document.main.flags_action.value='clear';
	document.main.flags.value='seen';
	simple_submit('set_flags,show','sw.htm');
}
function app_menu(type){
	if(type=='mail'){
		simple_submit('show','sw.htm');
	}else if(type=='contacts'){
		simple_submit('show','contacts.htm');
	}else{
		document.main.iframe_content.value=type;
		simple_submit('show','iframe.htm');
	}
}
function do_refresh(fid){
	F(fid,undefined,true);
}
function do_purge(fid){
	var o=document.main;
	o.fld_id.value=fid;
	o.sel_all.value='true';
	simple_submit('delete,show','sw.htm');
}
function manage_folders(fid){
	simple_submit('show','folders.htm');
}
function do_history(mid){
	alert("Not implemented");
}
function do_options(){
	simple_submit('show','options.htm');
}

function options_save(){
	var len=document.main.pref_signature.length;
	if(len>950){
		alert('Your signature is '+len+' characters long and currently cannot be longer than approx 970 characters - signature will be truncated, possibly resulting in odd behaviour.\n\nnote: html tag characters are part of character count');
	}
	simple_submit('save_options,show','sw.htm','options.htm');
}
function options_discard(){
	simple_submit('show','sw.htm');
}
function do_reply_all(){
	alert("Reply All, just doing a reply for now...");
	do_reply();
}

function nav(item){
	document.main.start.value=item;	
	simple_submit('show','sw.htm');
}

function do_attach()
{
	msg_from_editor();
	set_compose_refresh(); // only used if send error
	simple_submit('show','attach.htm');
}


function do_attach_upload()
{
	attach_uploading();
	simple_submit('attach_upload,show','attach.htm');
}
function do_attach_remove()
{
	var new_ids=[];
	var ids=document.main.attach_ids.value.split(',');
	for (var i=0;i<ids.length;i++){
		var o=dge('sel_'+ids[i]);
		if(o.checked) {
			class_add(o.parentNode,'hidden');
		}else{
			new_ids.push(ids[i]);
		}
	}
	document.main.attach_ids.value=new_ids.join(',');
}
var dots=1;
function attach_uploading(){
	var val="Uploading ";
	if (dots>=1) val=val+".";else val=val+" ";
	if (dots>=2) val=val+".";else val=val+" ";
	if (dots>=3) val=val+".";else val=val+" ";
	document.main.do_upload.value=val;
	dots=(dots+1)%4;
	setTimeout('attach_uploading()',500);
}
function live_refresh(){
	switch_to('html');
}



function do_copy_show(e,input)
{
	do_folder_menu_setup('folder_menu',true);
	do_menu_show('folder_menu', e, true, function(result,fid){
		if(result!='ok'){
			input.value='';
			return;	
		}

		document.main.destination.value=fid;
		simple_submit('msg_copy','sw.htm');
	});
}
function do_move_show(e,input)
{
	do_folder_menu_setup('folder_menu',true);
	do_menu_show('folder_menu',e,true,	function(result,fid){
		if(input) input.value='';
		if(result!='ok'){
			return;	
		}

		document.main.destination.value=fid;
		simple_submit('msg_move','sw.htm');
	});
}

